package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTIdentifier_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTIdentifier extends ISLASTExpression  {
	
	/* @generated */
	protected ISLASTIdentifier(long ptr) {
		/*** PROTECTED REGION ID(ISLASTIdentifier_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLASTIdentifier build(long ptr) {
		return new ISLASTIdentifier(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLASTIdentifier_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_expr_get_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier getID() {
		/*** PROTECTED REGION ID(isl_ast_expr_get_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_ast_expr_get_id(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLASTExpressionVisitor visitor) {
		visitor.visitISLASTIdentifier(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTIdentifier_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
